/* This software is contributed or developed by KYOCERA Corporation. */
/* (C) 2011 KYOCERA Corporation                                      */

#ifndef HS_IO_CTL_A_WS21_H
#define HS_IO_CTL_A_WS21_H
















#include "pmic.h"
#include "gpio.h"


extern void hs_vreg_ctl(const char* vreg_name, enum switch_cmd onoff);


#define GPIO_CAM_PWDN        GPIO_0
#define GPIO_CAM_RST         GPIO_1
#define	GPIO_CARD_DETB       GPIO_18
#define GPIO_VIB_EN          GPIO_79



#define GPIO_PS_OUT          GPIO_27


#define GPIO_GS_RSTN         GPIO_115





#define GPIO_GS_INT          GPIO_114



#define GPIO_LCD_CONNECT     GPIO_96


#define GPIO_REG_ON

#define GPIO_WL_RST_N        GPIO_16            
#define GPIO_BT_RST          GPIO_121           
#define GPIO_WL_WAKE_N       GPIO_108           
#define GPIO_MSM_WAKES_BT    GPIO_20            
#define GPIO_BT_WAKE_N       GPIO_30            
#define GPIO_MSM_WAKES_WLAN  GPIO_17            


#define GPIO_KYPD_0          GPIO_35
#define GPIO_KYPD_1          GPIO_34
#define GPIO_KYPD_2          GPIO_33
#define GPIO_KYPD_3          GPIO_32
#define GPIO_KYPD_4          GPIO_31
#define GPIO_KYPD_5          GPIO_30
#define GPIO_KYPD_6          GPIO_29
#define GPIO_KYPD_7          GPIO_28

#define GPIO_KEYSENSE_N_0    GPIO_42
#define GPIO_KEYSENSE_N_1    GPIO_41
#define GPIO_KEYSENSE_N_2    GPIO_40
#define GPIO_KEYSENSE_N_3    GPIO_39
#define GPIO_KEYSENSE_N_4    GPIO_38
#define GPIO_KEYSENSE_N_5    GPIO_37
#define GPIO_KEYSENSE_N_6    GPIO_36




#define HS_A_VIB_ON() \
  gpio_direction_output( GPIO_VIB_EN, GPIO_HI )
#define HS_A_VIB_OFF() \
  gpio_direction_output( GPIO_VIB_EN, GPIO_LO )




#define HS_A_CAM_RST_HI() \
  gpio_direction_output( GPIO_CAM_RST, GPIO_HI )

#define HS_A_CAM_RST_LO() \
  gpio_direction_output( GPIO_CAM_RST, GPIO_LO )



#define HS_A_CAM_PWDN_HI() \
  gpio_direction_output( GPIO_CAM_PWDN, GPIO_HI )

#define HS_A_CAM_PWDN_LO() \
  gpio_direction_output( GPIO_CAM_PWDN, GPIO_LO )



#define HS_A_CAM_VDD_D_CNT_HI() \
  hs_vreg_ctl("gp6", ON_CMD);

#define HS_A_CAM_VDD_D_CNT_LO() \
  hs_vreg_ctl("gp6", OFF_CMD);



#define HS_A_CAM_VDD_A_CNT_HI() \
  hs_vreg_ctl("gp1", ON_CMD);

#define HS_A_CAM_VDD_A_CNT_LO() \
  hs_vreg_ctl("gp1", OFF_CMD);




#define HS_A_CAM_VDD_IO_CNT_HI() \
  hs_vreg_ctl("pa", ON_CMD); \
  hs_vreg_ctl("gp2", ON_CMD);

#define HS_A_CAM_VDD_IO_CNT_LO() \
  hs_vreg_ctl("gp2", OFF_CMD); \
  hs_vreg_ctl("pa", OFF_CMD);



#define HS_A_CAM_VDD_AF_CNT_HI() \
  hs_vreg_ctl("gp5", ON_CMD);

#define HS_A_CAM_VDD_AF_CNT_LO() \
  hs_vreg_ctl("gp5", OFF_CMD);



#define HS_SPEAKER_POWER_ON() \
  hs_vreg_ctl("boost", ON_CMD);

#define HS_SPEAKER_POWER_OFF() \
  hs_vreg_ctl("boost", OFF_CMD);



#define HS_VREG_SYNT_ON() \
  hs_vreg_ctl("synt", ON_CMD);

#define HS_VREG_SYNT_OFF() \
  hs_vreg_ctl("synt", OFF_CMD);


#define HS_A_GS_RSTN_HI() \
    gpio_direction_output( GPIO_GS_RSTN, GPIO_HI)

#define HS_A_GS_RSTN_LO() \
    gpio_direction_output( GPIO_GS_RSTN, GPIO_LO)



#define HS_GET_LCD_CONNECT() \
  ( gpio_get_value( GPIO_LCD_CONNECT ) == GPIO_LO )




#define HS_A_REG_ON_HI()

#define HS_A_REG_ON_LO()


#define HS_A_WL_RST_N_HI() \
  gpio_direction_output( GPIO_WL_RST_N, GPIO_HI )

#define HS_A_WL_RST_N_LO() \
  gpio_direction_output( GPIO_WL_RST_N, GPIO_LO )


#define HS_A_WL_WAKE_N_HI() \
  gpio_direction_output( GPIO_WL_WAKE_N, GPIO_HI)
  
#define HS_A_WL_WAKE_N_LO() \
  gpio_direction_output( GPIO_WL_WAKE_N, GPIO_LO)


#define HS_A_QSD_WAKES_BT_HI() \
  gpio_direction_output( GPIO_MSM_WAKES_BT, GPIO_HI )

#define HS_A_QSD_WAKES_BT_LO() \
  gpio_direction_output( GPIO_MSM_WAKES_BT, GPIO_LO )


#define HS_A_BT_RST_HI() \
  gpio_direction_output( GPIO_BT_RST, GPIO_HI )

#define HS_A_BT_RST_LO() \
  gpio_direction_output( GPIO_BT_RST, GPIO_LO )


#endif 
