/*
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
*/



#ifndef __NT99250_H
#define __NT99250_H

#include <mach/board.h>
#include <mach/camera.h>

#define TRUE  1
#define FALSE 0


enum nt99250_width_t {
    BYTE_LEN,
    WORD_LEN,
    ADWORD_DATBYTE_LEN,
    ADWORD_DATLONG_LEN,
};

struct nt99250_i2c_reg_conf {
    unsigned short waddr;
    unsigned short wdata;
    enum nt99250_width_t  width;
    unsigned short mdelay_time;
};

struct nt99250_reg_t {
    unsigned short hw_ver_addr;

    struct nt99250_i2c_reg_conf const *init_reg_settings;
    uint16_t init_reg_settings_size;

    struct nt99250_i2c_reg_conf const *preview_reg_settings;
    uint16_t preview_reg_settings_size;

    struct nt99250_i2c_reg_conf const *still_reg_settings;
    uint16_t still_reg_settings_size;

    struct nt99250_i2c_reg_conf const *af_driver_data;
    uint16_t af_driver_data_size;
    struct nt99250_i2c_reg_conf const *macro_af_driver_data;
    uint16_t macro_af_driver_data_size;

    struct nt99250_i2c_reg_conf const *af_inf_to_macro_start;
    uint16_t af_inf_to_macro_start_reg_setting_size;
    struct nt99250_i2c_reg_conf const *af_macro_to_inf_start;
    uint16_t af_macro_to_inf_start_reg_setting_size;

    struct nt99250_i2c_reg_conf const *set_scene_auto_reg;
    struct nt99250_i2c_reg_conf const *set_scene_portrait_reg;
    struct nt99250_i2c_reg_conf const *set_scene_scenery_reg;
    struct nt99250_i2c_reg_conf const *set_scene_night_portrait_reg;
    struct nt99250_i2c_reg_conf const *set_scene_night_scenery_reg;
    struct nt99250_i2c_reg_conf const *set_scene_action_reg;
    uint16_t set_scene_reg_size;

    struct nt99250_i2c_reg_conf const *set_iso_auto_reg;
    struct nt99250_i2c_reg_conf const *set_iso_100_reg;
    struct nt99250_i2c_reg_conf const *set_iso_200_reg;
    struct nt99250_i2c_reg_conf const *set_iso_400_reg;
    uint16_t set_iso_reg_size;

    struct nt99250_i2c_reg_conf const *set_wb_auto_org;
    struct nt99250_i2c_reg_conf const *set_wb_auto_reg;
    struct nt99250_i2c_reg_conf const *set_wb_daylight_reg;
    struct nt99250_i2c_reg_conf const *set_wb_cloudy_reg;
    struct nt99250_i2c_reg_conf const *set_wb_incandescent_reg;
    struct nt99250_i2c_reg_conf const *set_wb_fluorescent_reg;

    uint16_t set_wb_reg_size;

    struct nt99250_i2c_reg_conf const *set_ae_mode_average_reg;
    struct nt99250_i2c_reg_conf const *set_ae_mode_center_reg;
    struct nt99250_i2c_reg_conf const *set_ae_mode_spot_reg;
    uint16_t set_ae_mode_reg_size;

    struct nt99250_i2c_reg_conf const *dataline_check_mode;
    uint16_t dataline_check_mode_reg_settings_size;

    struct nt99250_i2c_reg_conf const *wb_adj_mode;
    uint16_t wb_adj_mode_reg_settings_size;

    struct nt99250_i2c_reg_conf const *set_flash_mode;
    uint16_t set_flash_mode_reg_size;
};


extern struct nt99250_reg_t nt99250_regs;


int camsensor_flash_set_led_mode
(
  int
);

#endif
